#region Copyright Syncfusion Inc. 2001-2018.
// Copyright Syncfusion Inc. 2001-2018. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Intermodal.Models;
using Syncfusion.EJ.Export;
using Syncfusion.JavaScript.Models;
using System.Data.Entity;
using System.Web.Http;
using System.Web.Script.Serialization;

namespace Intermodal.Controllers
{
    public class HomeController : Controller
    {
        private mscPortalIntermodalEntities db = new mscPortalIntermodalEntities();

        
        public ActionResult Index()
        {
            var Data = (from H in db.Intermodal_Haulage_Temp
                              join T in db.Transport_Mode on H.Transport_Mode_id equals T.Transport_Mode_id
                              join CH in db.Charges on H.Charge equals CH.Charge1
                              join CU in db.Currencies on H.Currency_Profit_id equals CU.Currency_id
                              orderby H.Customer_Appointment_Date descending
                              select new
                              {
                                  H.Haulage_ID,
                                  H.Cargo_Shipment_ID,
                                  H.Cargo_Shipment_Container_ID,
                                  H.Vessel,
                                  H.Voyage,
                                  H.Service,
                                  H.Is_Export,
                                  H.Booking,
                                  H.BL,
                                  H.Origin,
                                  H.Final_Dest,
                                  H.POL,
                                  H.POD,
                                  H.Cross_Booking,
                                  H.Container,
                                  H.Abbrev,
                                  H.Is_Hazardous,
                                  H.OverDimensions,
                                  H.Weight,
                                  H.S_Loca,
                                  H.S_Depot,
                                  H.E_Loca,
                                  H.E_Depot,
                                  H.Profit,
                                  H.Customer_Appointment_Date,
                                  CH.Design,
                                  T.Name,
                                  CU.ISO_Code
                              }).ToList();

            //var Currency = (from c in db.Currencies
            //                select new { id = c.Currency_id, ISO = c.ISO_Code }).ToList();

            ViewBag.datasource = Data;
            //ViewBag.Currency = Currency;
            //var Carrier = (from c in db.Carriers
            //               orderby c.Name
            //               select new { id = c.Carrier_Number, Name = c.Name }).ToList();

            //ViewBag.carrier = Carrier;

            //var Mode = (from t in db.Transport_Mode
            //            orderby t.Name
            //            select new { id = t.Transport_Mode_id, Name = t.Name }).ToList();

            //ViewBag.Mode = Mode;
            return View();
        }

        public void ExportToExcel(string GridModel)
        {
            ExcelExport exp = new ExcelExport();
            var DataSource = (from H in db.Intermodal_Haulage_Temp
                              join T in db.Transport_Mode on H.Transport_Mode_id equals T.Transport_Mode_id
                              join CH in db.Charges on H.Charge equals CH.Charge1
                              join CU in db.Currencies on H.Currency_Profit_id equals CU.Currency_id
                              orderby H.Customer_Appointment_Date descending
                              select new
                              {
                                  H.Haulage_ID,
                                  H.Cargo_Shipment_ID,
                                  H.Cargo_Shipment_Container_ID,
                                  H.Vessel,
                                  H.Voyage,
                                  H.Service,
                                  H.Is_Export,
                                  H.Booking,
                                  H.BL,
                                  H.Origin,
                                  H.Final_Dest,
                                  H.POL,
                                  H.POD,
                                  H.Cross_Booking,
                                  H.Container,
                                  H.Abbrev,
                                  H.Is_Hazardous,
                                  H.OverDimensions,
                                  H.Weight,
                                  H.S_Loca,
                                  H.S_Depot,
                                  H.E_Loca,
                                  H.E_Depot,
                                  H.Profit,
                                  H.Customer_Appointment_Date,
                                  CH.Design,
                                  T.Name,
                                  CU.ISO_Code
                              }).ToList();
            GridProperties obj = (GridProperties)Syncfusion.JavaScript.Utils.DeserializeToModel(typeof(GridProperties), GridModel);
            exp.Export(obj, DataSource, "Export.xlsx", Syncfusion.XlsIO.ExcelVersion.Excel2016, false, false, "flat-saffron");
        }

        public JsonResult Currency()
        {
            var Currency = (from c in db.Currencies
                            orderby c.ISO_Code
                            select new { id = c.Currency_id, ISO = c.ISO_Code }).ToList();

            var jsonSerializer = new JavaScriptSerializer();
            return Json(jsonSerializer.Serialize(Currency));
        }

        public JsonResult Carrier()
        {
            var Carrier = (from c in db.Carriers
                            orderby c.Name
                            select new { id = c.Carrier_Number, Name = c.Name }).ToList();

            var jsonSerializer = new JavaScriptSerializer();
            return Json(jsonSerializer.Serialize(Carrier));
        }

        public JsonResult Trnasport_Mode()
        {
            var Mode = (from t in db.Transport_Mode
                           orderby t.Name
                           select new { id = t.Transport_Mode_id, Name = t.Name }).ToList();

            var jsonSerializer = new JavaScriptSerializer();
            return Json(jsonSerializer.Serialize(Mode));
        }

        public JsonResult Location()
        {
            var Location = (from l in db.Locations
                        orderby l.Global_Name
                        select new { id = l.Location_id, Name = l.Global_Name }).ToList();

            var jsonSerializer = new JavaScriptSerializer();
            return Json(jsonSerializer.Serialize(Location));
        }

        //public ActionResult Edit(Intermodal_Leg_Temp value)
        //{
        //    Intermodal_Leg_Temp Intermodal_Leg_Temp = db.Intermodal_Leg_Temp.Find(value.Leg_ID);

        //    Intermodal_Leg_Temp.Estimated_Cost = value.Estimated_Cost;
        //    Intermodal_Leg_Temp.Additional_Cost = value.Additional_Cost;
        //    db.SaveChanges();

        //    var DataSource = (from H in db.Intermodal_Haulage_Temp
        //                      join T in db.Transport_Mode on H.Transport_Mode_id equals T.Transport_Mode_id
        //                      join CH in db.Charges on H.Charge equals CH.Charge1
        //                      join CU in db.Currencies on H.Currency_Profit_id equals CU.Currency_id
        //                      orderby H.Customer_Appointment_Date descending
        //                      select new
        //                      {
        //                          H.Haulage_ID,
        //                          H.Cargo_Shipment_ID,
        //                          H.Cargo_Shipment_Container_ID,
        //                          H.Vessel,
        //                          H.Voyage,
        //                          H.Service,
        //                          H.Is_Export,
        //                          H.Booking,
        //                          H.BL,
        //                          H.Origin,
        //                          H.Final_Dest,
        //                          H.POL,
        //                          H.POD,
        //                          H.Cross_Booking,
        //                          H.Container,
        //                          H.Abbrev,
        //                          H.Is_Hazardous,
        //                          H.OverDimensions,
        //                          H.Weight,
        //                          H.S_Loca,
        //                          H.S_Depot,
        //                          H.E_Loca,
        //                          H.E_Depot,
        //                          H.Profit,
        //                          H.Customer_Appointment_Date,
        //                          CH.Design,
        //                          T.Name,
        //                          CU.ISO_Code
        //                      }).ToList();
        //    return Json(DataSource, JsonRequestBehavior.AllowGet);
        //}

        //private GridProperties ConvertGridObject(string gridProperty)
        //{
        //    JavaScriptSerializer serializer = new JavaScriptSerializer();
        //    IEnumerable div = (IEnumerable)serializer.Deserialize(gridProperty, typeof(IEnumerable));
        //    GridProperties gridProp = new GridProperties();
        //    foreach (KeyValuePair<string, object> ds in div)
        //    {
        //        var property = gridProp.GetType().GetProperty(ds.Key, BindingFlags.Instance | BindingFlags.Public | BindingFlags.IgnoreCase);
        //        if (property != null)
        //        {
        //            Type type = property.PropertyType;
        //            string serialize = serializer.Serialize(ds.Value);
        //            object value = serializer.Deserialize(serialize, type);
        //            property.SetValue(gridProp, value, null);
        //        }
        //    }
        //    return gridProp;
        //}

        public ActionResult About()
        {
            ViewBag.Message = "Your application description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }
    }
}